require(GlobalDependencys:GetDependency("StandardBase"):GetPackageName())

--GAME VARS
fDefaultFOV = 85
fAdditionalFOV = 0
fAspectRatio = DisplayInfo:GetWidth() / DisplayInfo:GetHeight()
fAspectRatio169 = 1.777777791
fFactor = 0.00872665
fHUDSafeZOneLeft = 0
fHUDSafeZoneRight = 0

--ControlVars
bFixEnabled = true
bFOV = true
bAspect = true
bHUDSafeZone = true
bCinematicsFPS = true
bFringe = true
bDOF = true

--PROCESS VARS
Process_FriendlyName = Module:GetFriendlyName()
Process_WindowName = "*"
Process_ClassName = "UnrealWindow"
Process_EXEName = "O2-Win64-Shipping.exe"

--INJECTION BEHAVIOUR
InjectDelay = 500
WriteInterval = 100
SearchInterval = 100
SuspendThread = true

--Name                         Manual/Auto/Hybrid  		Steam/Origin/Any                IncludeFile:Configure;Enable;Periodic;Disable;
SupportedVersions = { 		
{"Automatically Detect",       "Hybrid",  			"Any",	                         "Configure_SignatureScan;Enable_Inject;Periodic;Disable_Inject;"},
}

function Init_Controls()

	DefaultControls.AddHeader("Header_FixesEnableDisable","Individual Fixes",245,70,210,17)
	
	DefaultControls.AddHeader("Header_FOV","FOV fine adjustment",15,70,210,17)	
	DefaultControls.AddFixedFOVSlider("FOVSlider","FOVSlider_Changed",55,100,125,35,0,60,0,1)
	FOVSlider:SetTickFrequency(5)
	FOVSlider:SetLabel1Text("-20")
	FOVSlider:SetLabel2Text("+40")
	
	DefaultControls.AddHeader("HeaderHUDSZ","HUD safe zone",15,160,210,17)	
	DefaultControls.AddFixedFOVSlider("HUD","HUDSZSlider_Changed",55,190,125,35,0,40,0,1)
	HUD:SetTickFrequency(5)
	HUD:SetLabel1Text("0")
	HUD:SetLabel2Text("40")

	DefaultControls.AddFixToggle("CKFOVFix_Enable","FOV fix","CKFOVFix_Changed",255,101,180,14)
	DefaultControls.AddFixToggle("CKARFix_Enable","Cinematics aspect ratio fix","CKARFix_Changed",255,121,180,14)
	DefaultControls.AddFixToggle("CKHUDFix_Enable","HUD safe zone fix","CKHUDFix_Changed",255,141,180,14)
	DefaultControls.AddFixToggle("CKFPSFix_Enable","Cinematics FPS fix","CKCINEMATICSFPSFix_Changed",255,161,180,14)
	DefaultControls.AddFixToggle("CKFRINGEFix_Enable","Chromatic aberration fix","CKFRINGEFix_Changed",255,181,180,14)
	DefaultControls.AddFixToggle("CKDOFFix_Enable","Depth of field fix","CKDOFFix_Changed",255,201,180,14)
	
end

function Configure_SignatureScan() 
	
	local tAddress = HackTool:AddAddress("FOV")
	
	if HackTool:SignatureScan("C6 84 ?? ?? ?? ?? ?? ?? 48 ?? ?? 74 ?? E8 ?? ?? ?? ?? 0F ?? ?? 48 8B ?? ?? ?? ?? ?? ?? 48 ?? ?? E8 ?? ?? ?? ?? 0F 28 ?? ?? ?? ?? ?? ?? 48 81",tAddress,PAGE_EXECUTE_READ,0x12,Process_EXEName) == 0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--O2-Win64-Shipping.exe+3A0CBDD - 74 05                 	- je O2-Win64-Shipping.exe+3A0CBE4
		--O2-Win64-Shipping.exe+3A0CBDF - E8 7C 51 3B FE           	- call O2-Win64-Shipping.exe+1DC1D60
		--O2-Win64-Shipping.exe+3A0CBE4 - 0F 28 C6               	- movaps xmm0,xmm6
		--O2-Win64-Shipping.exe+3A0CBE7 - 48 8B 8C 24 20 06 00 00  	- mov rcx,[rsp+00000620]
		--O2-Win64-Shipping.exe+3A0CBEF - 48 33 CC              	- xor rcx,rsp
	end


	local tAddress = HackTool:AddAddress("ASPECT")
	
	if HackTool:SignatureScan("76 ?? F3 0F 10 ?? ?? ?? ?? ?? F3 0F ?? ?? F3 0F ?? ?? ?? ?? ?? ?? F3 0F ?? ?? ?? ?? ?? ?? 0F 28",tAddress,PAGE_EXECUTE_READ,0x0e,Process_EXEName) == 0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--O2-Win64-Shipping.exe+336F7D2 - 76 27                 	- jna O2-Win64-Shipping.exe+336F7FB
		--O2-Win64-Shipping.exe+336F7D4 - F3 0F 10 83 DC 07 00 00   - movss xmm0,[rbx+000007DC]
		--O2-Win64-Shipping.exe+336F7DC - F3 0F 5E C1            	- divss xmm0,xmm1
		--O2-Win64-Shipping.exe+336F7E0 - F3 0F 11 83 E4 07 00 00   - movss [rbx+000007E4],xmm0
		--O2-Win64-Shipping.exe+336F7E8 - F3 0F 11 83 08 02 00 00   - movss [rbx+00000208],xmm0
	end
	
	local tAddress = HackTool:AddAddress("HUDSAFEZONE")
	
	if HackTool:SignatureScan("48 8B ?? ?? ?? 0F ?? ?? 48 ?? ?? 0F ?? ?? 48 83 ?? ?? 5F",tAddress,PAGE_EXECUTE_READ,0x05,Process_EXEName) == 0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--O2-Win64-Shipping.exe+32DA69A - FF D0                 - call rax
		--O2-Win64-Shipping.exe+32DA69C - 48 8B 5C 24 40        - mov rbx,[rsp+40]
		--O2-Win64-Shipping.exe+32DA6A1 - 0F 10 00              - movups xmm0,[rax]
		--O2-Win64-Shipping.exe+32DA6A4 - 48 8B C7              - mov rax,rdi
		--O2-Win64-Shipping.exe+32DA6A7 - 0F 11 07              - movups [rdi],xmm0
	end
	
	local tAddress = HackTool:AddAddress("CINEMATICSFPS")
	
	if HackTool:SignatureScan("F3 0F ?? ?? ?? E8 ?? ?? ?? ?? 8B ?? 48 ?? ?? E8",tAddress,PAGE_EXECUTE_READ,0x0,Process_EXEName) == 0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--O2-Win64-Shipping.exe+1DA82E1 - F2 0F 5A C8           - cvtsd2ss xmm1,xmm0
		--O2-Win64-Shipping.exe+1DA82E5 - 44 8B CE              - mov r9d,esi
		--O2-Win64-Shipping.exe+1DA82E8 - F3 0F 11 4F 48        - movss [rdi+48],xmm1
		--O2-Win64-Shipping.exe+1DA82ED - E8 9E 80 FE FF        - call O2-Win64-Shipping.exe+1D90390
		--O2-Win64-Shipping.exe+1DA82F2 - 8B D6                 - mov edx,esi
	end
	
	local tAddress = HackTool:AddAddress("FRINGE")
	
	if HackTool:SignatureScan("7F ?? 89 B3 ?? ?? ?? ?? 8B ?? ?? 39 05",tAddress,PAGE_EXECUTE_READ,0x0,Process_EXEName) == 0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--O2-Win64-Shipping.exe+3A9845A - 48 8B 05 1F 16 8F 02  - mov rax,[O2-Win64-Shipping.exe+6389A80]
		--O2-Win64-Shipping.exe+3A98461 - 39 30                 - cmp [rax],esi
		--O2-Win64-Shipping.exe+3A98463 - 7F 06                 - jg O2-Win64-Shipping.exe+3A9846B
		--O2-Win64-Shipping.exe+3A98465 - 89 B3 84 10 00 00     - mov [rbx+00001084],esi
		--O2-Win64-Shipping.exe+3A9846B - 8B 04 2F              - mov eax,[rdi+rbp]
	end
	
	local tAddress = HackTool:AddAddress("DOF")
	
	if HackTool:SignatureScan("8B ?? ?? E8 ?? ?? ?? ?? 8B ?? E8 ?? ?? ?? ?? 84 ?? 74 ?? 48",tAddress,PAGE_EXECUTE_READ,0x0,Process_EXEName) == 0 then
		return ErrorOccurred(string.format(SigScanError,tAddress:GetName()))
	else	
		print( tAddress:GetInfo(TYPE_ADDRESS) )
		--O2-Win64-Shipping.exe+3A9845A - 48 8B 05 1F 16 8F 02  - mov rax,[O2-Win64-Shipping.exe+6389A80]
		--O2-Win64-Shipping.exe+3A98461 - 39 30                 - cmp [rax],esi
		--O2-Win64-Shipping.exe+3A98463 - 7F 06                 - jg O2-Win64-Shipping.exe+3A9846B
		--O2-Win64-Shipping.exe+3A98465 - 89 B3 84 10 00 00     - mov [rbx+00001084],esi
		--O2-Win64-Shipping.exe+3A9846B - 8B 04 2F              - mov eax,[rdi+rbp]
	end
	
	return true
end

function Enable_Inject()

	local Variables = HackTool:AllocateMemory("Variables",0)
	Variables:PushFloat("CompensatedFOV")
	Variables:PushFloat("FOVIn")
	Variables:PushFloat("FOVOut")
	Variables:PushFloat("AdditionalFOV")
	Variables:PushFloat("AspectRatio")
	Variables:PushFloat("ScreenRatio")
	Variables:PushFloat("factor")
	Variables:PushFloat("HUDSafeZoneLeft")
	Variables:PushFloat("HUDSafeZoneTop")
	Variables:PushFloat("HUDSafeZoneRight")
	Variables:PushFloat("HUDSafeZoneBottom")
	Variables:PushFloat("HUDSafeZoneDefRight")
	Variables:PushFloat("HUDSafeZoneDefBottom")
	Variables:Allocate()
	Variables["FOVIn"]:WriteFloat(fDefaultFOV)
	Variables["FOVOut"]:WriteFloat(fDefaultFOV)
	Variables["AdditionalFOV"]:WriteFloat(fAdditionalFOV)
	Variables["AspectRatio"]:WriteFloat(fAspectRatio169)
	Variables["ScreenRatio"]:WriteFloat(fAspectRatio)
	Variables["factor"]:WriteFloat(fFactor)
	Variables["HUDSafeZoneLeft"]:WriteFloat(0)
	Variables["HUDSafeZoneTop"]:WriteFloat(0)
	Variables["HUDSafeZoneRight"]:WriteFloat(1)
	Variables["HUDSafeZoneBottom"]:WriteFloat(1)
	Variables["HUDSafeZoneDefRight"]:WriteFloat(1)
	Variables["HUDSafeZoneDefBottom"]:WriteFloat(1)
	
	ResolutionChanged()	
	
	local asm = [[	

		(codecave:jmp)FOV,FOV_cc:
			movss [(allocation)Variables->FOVIn],$$2						$ctx=1
			fld dword ptr [(allocation)Variables->FOVIn]
			fmul dword ptr [(allocation)Variables->factor]
			fptan
			fstp st0
			fld dword ptr [(allocation)Variables->ScreenRatio]
			fdiv dword ptr [(allocation)Variables->AspectRatio]
			fmulp st1,st0
		    fld1
		    fpatan
			fdiv dword ptr [(allocation)Variables->factor]						; calculate compensated FOV
			fstp dword ptr [(allocation)Variables->CompensatedFOV]				; and retrieve it			
			movss $$2,[(allocation)Variables->CompensatedFOV]				$ctx=1
			addss $$2,[(allocation)Variables->AdditionalFOV]				$ctx=1
			movss [(allocation)Variables->FOVOut],$$2						$ctx=1
			%originalcode%
			jmp %returnaddress%
			%end%

		(codecave:jmp)ASPECT,ASPECT_cc:
			$$0 $$2,[(allocation)Variables->ScreenRatio]					$ctx=1
			%originalcode%
			jmp %returnaddress%
			%end%
									
		(codecave:jmp)HUDSAFEZONE,HUDSAFEZONE_cc:
			movsd xmm14,[$$2+8]												$ctx=1
			ucomisd xmm14,[(allocation)Variables->HUDSafeZoneDefRight]
			jne next			
			$$0 xmm14,[(allocation)Variables->HUDSafeZoneLeft]				$ctx=1
			$$0 [$$2],xmm14													$ctx=1
			
			next:
			%originalcode%			
			jmp %returnaddress%
			%end%
			
		(codecave:jmp)CINEMATICSFPS,CINEMATICSFPS_cc:
			comiss $$2,[FPSLimit]											$ctx=1
			je %returnaddress%
			%originalcode%			
			jmp %returnaddress%
			%end%
			
			FPSLimit: (float)30f
			
		(codecave)DOF,DOF_cc:
			xor $$1,$$1														$ctx=1
			nop
			%end%
			
		(codecave)FRINGE,FRINGE_cc:
			nop
			nop
			%end%
			
	]]

	if HackTool:CompileAssembly(asm,"Fixes") == nil then
		return ErrorOccurred("Assembly compilation failed...")
	else
		Toggle_CodeCave("FOV_cc",bFOV)
		Toggle_CodeCave("ASPECT_cc",bAspect)
		Toggle_CodeCave("HUDSAFEZONE_cc",bHUDSafeZone)
		Toggle_CodeCave("CINEMATICSFPS_cc",bCinematicsFPS)
		Toggle_CodeCave("FRINGE_cc",bFringe)
		Toggle_CodeCave("DOF_cc",bDOF)
	end	
			
	Write_FOV()
	Write_HUD_Safe_Zone()
	
end

function Periodic()
	local Variables = HackTool:GetAllocation("Variables")
	
	if Variables and Variables["FOVIn"] and Variables["AdditionalFOV"] then
		local fCompensatedFOV = Variables["CompensatedFOV"]:ReadFloat()
		local fFOVIn = Variables["FOVIn"]:ReadFloat()
		local fFOVOut = Variables["FOVOut"]:ReadFloat()
		PluginViewport:AppendStatusMessage( string.format("\r\n===== Fix informations =====\r\nFOV In: %.2f, Compensated FOV: %.2f, FOV Out: %.2f", fFOVIn, fCompensatedFOV, fFOVOut))
	end
end

function FOVSlider_Changed(Sender)

	fAdditionalFOV = Sender:GetPosition() - 20
	lblFOVSlider.Caption:SetCaption( string.format("Value: +%.0f",fAdditionalFOV) )		
	Write_FOV()
	ForceUpdate()

end

function Write_FOV()

	local Variables = HackTool:GetAllocation("Variables")
	if Variables and Variables["AdditionalFOV"] then
		if bFOV == true then
			Variables["AdditionalFOV"]:WriteFloat(fAdditionalFOV)
		else
			Variables["AdditionalFOV"]:WriteFloat(0)
		end
	end

end

function Write_HUD_Safe_Zone()

	local Variables = HackTool:GetAllocation("Variables")
	
	if Variables and Variables["HUDSafeZoneLeft"] and Variables["HUDSafeZoneRight"] then
		Variables["HUDSafeZoneLeft"]:WriteFloat(fHUDSafeZOneLeft / 100)
		Variables["HUDSafeZoneRight"]:WriteFloat(1 - (fHUDSafeZoneRight / 100))
	end
	
end

function Disable_Inject()
	
	CleanUp()
	
end

function CKFOVFix_Changed(Sender)

	bFOV = Toggle_CheckFix(Sender)
	Toggle_CodeCave("FOV_cc",bFOV)
	Write_FOV()
	ForceUpdate()
	
end

function CKARFix_Changed(Sender)

	bAspect = Toggle_CheckFix(Sender)
	Toggle_CodeCave("ASPECT_cc",bAspect)
	ForceUpdate()
	
end

function CKHUDFix_Changed(Sender)

	bHUDSafeZone = Toggle_CheckFix(Sender)
	Toggle_CodeCave("HUDSAFEZONE_cc",bHUDSafeZone)
	ForceUpdate()

end

function CKCINEMATICSFPSFix_Changed(Sender)

	bCinematicsFPS = Toggle_CheckFix(Sender)
	Toggle_CodeCave("CINEMATICSFPS_cc",bCinematicsFPS)
	ForceUpdate()

end

function CKFRINGEFix_Changed(Sender)

	bFringe = Toggle_CheckFix(Sender)
	Toggle_CodeCave("FRINGE_cc",bFringe)
	ForceUpdate()

end

function CKDOFFix_Changed(Sender)

	bDOF = Toggle_CheckFix(Sender)
	Toggle_CodeCave("DOF_cc",bDOF)
	ForceUpdate()

end

function HUDSZSlider_Changed(Sender)

	fHUDSafeZOneLeft = Sender:GetPosition()
	fHUDSafeZoneRight = fHUDSafeZOneLeft
	lblHUD.Caption:SetCaption( string.format("+ %.0f %%",fHUDSafeZOneLeft) )
	Write_HUD_Safe_Zone()
	ForceUpdate()
	
end

function ResolutionChanged() 

	SyncDisplayDetection()
	
end

function Init()

	Init_BaseControls()
	Init_Controls()

end

function DeInit()

	DisableFix()

end
